/**
 * Description: CmExchangeCodeWS接口
 * Copyright:   Copyright (c)2015
 * Company:     江苏三六五网络股份有限公司
 *
 * @author: 江苏三六五网络股份有限公司
 * @version: 1.0
 * Create at:   2015-08-10 下午 17:06:13
 * <p>
 * Modification History:
 * Date         Author      Version     Description
 * ------------------------------------------------------------------
 * 2015-08-10   江苏三六五网络股份有限公司   1.0         Initial
 */
package com.house365.ws.interfaces.impl;

import com.house365.beans.entity.CmExchangeCodeEntity;
import com.house365.beans.system.QueryParams;
import com.house365.rest.context.Parameter;
import com.house365.rest.exception.ServiceRunException;
import com.house365.ws.beans.request.CmExchangeCodeListRequest;
import com.house365.ws.beans.request.CmExchangeCodeRequest;
import com.house365.ws.beans.response.CmExchangeCodeListResponse;
import com.house365.ws.beans.response.CmExchangeCodeResponse;
import com.house365.ws.interfaces.server.ICmExchangeCode;
import com.house365.ws.service.interfaces.ICmExchangeCodeService;
import com.house365.ws.system.ReturnResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * CmExchangeCodeWS接口<br>
 *
 * @author 江苏三六五网络股份有限公司
 * @version 1.0, 2015-08-10
 * @see
 * @since 1.0
 */
@Service("cmExchangeCode")
public class CmExchangeCodeImpl implements ICmExchangeCode {
    /**
     * 日志记录器
     */
    private static final Logger LOGGER = LoggerFactory.getLogger(CmExchangeCodeImpl.class);

    /**
     * CmExchangeCode服务对象
     */
    @Autowired
    private ICmExchangeCodeService<CmExchangeCodeEntity> cmExchangeCodeService;

    /**
     * CmExchangeCode列表查询
     *
     * @param request CmExchangeCode列表查询请求
     * @return CmExchangeCode列表查询响应
     */
    @Override
    public CmExchangeCodeListResponse getCmExchangeCodeList(CmExchangeCodeListRequest request) {
        CmExchangeCodeListResponse response = new CmExchangeCodeListResponse();
        try {
            QueryParams<CmExchangeCodeEntity> queryParams = new QueryParams<>(request.getSearchParams());
            queryParams.setPaging(request.getPaging());
            List<CmExchangeCodeEntity> cmExchangeCodes = cmExchangeCodeService.queryByPage(queryParams);
            response.setPaging(queryParams.getPaging());
            response.setObjectList(cmExchangeCodes);
            response.setResultCode(ReturnResult.SUCCESS.getResultCode());
            response.setResultMessage(ReturnResult.SUCCESS.getResultMessage());
        } catch (Exception ex) {
            LOGGER.error(ex.getMessage(), ex);
            response.setResultCode(ReturnResult.FAIL.getResultCode());
            response.setResultMessage(ex.getMessage());
        }
        return response;
    }

    /**
     * 保存CmExchangeCode
     *
     * @param request CmExchangeCode请求
     * @return 保存CmExchangeCode响应
     */
    @Override
    public CmExchangeCodeResponse addCmExchangeCode(CmExchangeCodeRequest request) {
        CmExchangeCodeResponse response = new CmExchangeCodeResponse();
        try {
            CmExchangeCodeEntity entity = request.getEntity();
            cmExchangeCodeService.save(entity);
            response.setEntity(entity);
            response.setResultCode(ReturnResult.SUCCESS.getResultCode());
            response.setResultMessage(ReturnResult.SUCCESS.getResultMessage());
        } catch (Exception ex) {
            LOGGER.error(ex.getMessage(), ex);
            response.setResultCode(ReturnResult.FAIL.getResultCode());
            response.setResultMessage(ex.getMessage());
        }
        return response;
    }

    /**
     * 删除CmExchangeCode通过唯一标识
     *
     * @param id 唯一标识
     * @return 删除CmExchangeCode响应
     */
    @Override
    public CmExchangeCodeResponse deleteCmExchangeCodeById(Integer id) {
        CmExchangeCodeResponse response = new CmExchangeCodeResponse();
        try {
            cmExchangeCodeService.delete(id);
            response.setResultCode(ReturnResult.SUCCESS.getResultCode());
            response.setResultMessage(ReturnResult.SUCCESS.getResultMessage());
        } catch (Exception ex) {
            LOGGER.error(ex.getMessage(), ex);
            response.setResultCode(ReturnResult.FAIL.getResultCode());
            response.setResultMessage(ex.getMessage());
        }
        return response;
    }

    /**
     * 删除CmExchangeCode通过Batch
     *
     * @param batchId 批次号
     * @return 删除CmExchangeCode响应
     */
    @Override
    public CmExchangeCodeResponse deleteByBatchCode(Integer batchId) {
        CmExchangeCodeResponse response = new CmExchangeCodeResponse();
        try {
            cmExchangeCodeService.deleteByBatchCode(batchId);
            response.setResultCode(ReturnResult.SUCCESS.getResultCode());
            response.setResultMessage(ReturnResult.SUCCESS.getResultMessage());
        } catch (Exception ex) {
            LOGGER.error(ex.getMessage(), ex);
            response.setResultCode(ReturnResult.FAIL.getResultCode());
            response.setResultMessage(ex.getMessage());
            throw ex;
        }
        return response;
    }

    /**
     * 修改CmExchangeCode
     *
     * @param request 修改CmExchangeCode请求
     * @return 修改CmExchangeCode响应
     */
    @Override
    public CmExchangeCodeResponse updateCmExchangeCode(CmExchangeCodeRequest request) {
        CmExchangeCodeResponse response = new CmExchangeCodeResponse();
        try {
            cmExchangeCodeService.update(request.getEntity());
            response.setResultCode(ReturnResult.SUCCESS.getResultCode());
            response.setResultMessage(ReturnResult.SUCCESS.getResultMessage());
        } catch (Exception ex) {
            LOGGER.error(ex.getMessage(), ex);
            response.setResultCode(ReturnResult.FAIL.getResultCode());
            response.setResultMessage(ex.getMessage());
        }
        return response;
    }

    /**
     * 通过ID获取CmExchangeCode
     *
     * @param id 唯一标识
     * @return 通过ID获取CmExchangeCode响应
     */
    @Override
    public CmExchangeCodeResponse getCmExchangeCodeById(Integer id) {
        CmExchangeCodeResponse response = new CmExchangeCodeResponse();
        try {
            CmExchangeCodeEntity entity = cmExchangeCodeService.getById(id);
            response.setEntity(entity);
            response.setResultCode(ReturnResult.SUCCESS.getResultCode());
            response.setResultMessage(ReturnResult.SUCCESS.getResultMessage());
        } catch (Exception ex) {
            LOGGER.error(ex.getMessage(), ex);
            response.setResultCode(ReturnResult.FAIL.getResultCode());
            response.setResultMessage(ex.getMessage());
        }
        return response;
    }


    /**
     * 以下均为自动生成
     */

    @Override
    public Object exectue(Parameter parameter) throws ServiceRunException {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public boolean isControlService() {
        return false;
    }

    @Override
    public boolean isLogService() {
        return false;
    }

    @Override
    public boolean isMonitorService() {
        return false;
    }

    @Override
    public Object rollback() {
        return null;
    }

    @Override
    public void commit() {
    }
}
